﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication3
{
	public partial class MainPage : UserControl
	{
		private Dictionary<object, int> itemToPositionMap;
		private int maximizedItemPosition = -1;

		public MainPage()
		{
			InitializeComponent();

			this.itemToPositionMap = new Dictionary<object, int>();
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			this.myTileView.Items.Clear();

			if (this.myInfo.IsChecked.Value)
			{
				this.myTileView.Items.Add(new MyInfo());
			}
			if (this.myNotes.IsChecked.Value)
			{
				this.myTileView.Items.Add(new MyNotes());
			}
		}

		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			this.itemToPositionMap.Clear();

			foreach (var item in this.myTileView.Items)
			{
				var container = this.myTileView.ItemContainerGenerator.ContainerFromItem(item) as RadTileViewItem;
				if (container != null)
				{
					this.itemToPositionMap[item] = container.Position;
				}
			}

			if (this.myTileView.MaximizedItem != null)
			{
				this.maximizedItemPosition = (this.myTileView.ItemContainerGenerator.ContainerFromItem(this.myTileView.MaximizedItem) as RadTileViewItem).Position;
			}
			else
			{
				this.maximizedItemPosition = -1;
			}
		}

		private void Button_Click_2(object sender, RoutedEventArgs e)
		{
			//Ensure all items 
			foreach (var item in this.itemToPositionMap)
			{
				if (!this.myTileView.Items.Contains(item.Key))
				{
					this.myTileView.Items.Add(item.Key);
				}
			}

			//Set positions
			this.Dispatcher.BeginInvoke(new Action(() =>
			{
				this.EnsurePositions();
			}));
		}

		private void EnsurePositions()
		{
			foreach (var item in this.itemToPositionMap)
			{
				if (this.myTileView.Items.Contains(item.Key))
				{
					var container = this.myTileView.ItemContainerGenerator.ContainerFromItem(item.Key) as RadTileViewItem;
					if (container != null)
					{
						container.Position = item.Value;
						if (this.maximizedItemPosition == item.Value)
						{
							this.myTileView.MaximizedItem = item.Key;
						}
					}
				}
			}
		}

		private void Button_Click_3(object sender, RoutedEventArgs e)
		{
			this.myTileView.Items.Clear();
		}
	}
}
